// SFStatusInfo.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "MonLog.h"
#include "SFStatusInfo.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSFStatusInfo

/////////////////////////////////////////////////////////////////////////////
// 

CStatusBar* CSFStatusInfo::GetStatusBar()
{
	CWinApp*	pApp = (CWinApp*)AfxGetApp();	
	ASSERT_VALID( pApp );

	CMainFrame*	pMain = (CMainFrame*)pApp->m_pMainWnd;
	if( pMain == NULL )
		return NULL;
	ASSERT_VALID( pMain );

	CStatusBar*	pStatus = pMain->GetStatusBar();
	ASSERT_VALID( pStatus );

	return pStatus;
}

/////////////////////////////////////////////////////////////////////////////
// 

void CSFStatusInfo::MessageTextOut(const CString& message)
{
	CStatusBar*	pStatus = GetStatusBar();

	if( pStatus ) {
		pStatus->SetPaneText( 0, message );
	}
}

/////////////////////////////////////////////////////////////////////////////
// 

void CSFStatusInfo::numTextOut( int iNum )
{
	CString	viewText;

	if( iNum ) {
		viewText.Format( SFSUT_NUM_MASK, iNum );
	}
	else {
		viewText = _T("");
	}

	CStatusBar*	pStatus = GetStatusBar();

	if( pStatus ) {
		pStatus->SetPaneText( SFSUT_NUM_INDEX, viewText );
	}
}

/////////////////////////////////////////////////////////////////////////////
// 

void CSFStatusInfo::svcTextOut( BOOL bRun )
{
	CString	viewText;

	viewText.Format( SFSUT_SVC_MASK, bRun ? "쒆" : "~" );

	CStatusBar*	pStatus = GetStatusBar();

	if( pStatus ) {
		pStatus->SetPaneText( SFSUT_SVC_INDEX, viewText );
	}
}

