// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "MonLog.h"

#include "MainFrm.h"

#include "MonLogDoc.h"
#include "SFListView.h"
#include "SFTreeView.h"

#include "SFStatusInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_OPE_UPDATE, OnOpeUpdate)
	ON_UPDATE_COMMAND_UI(ID_OPE_UPDATE, OnUpdateOpeUpdate)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DELETE, OnUpdateEditDelete)
	ON_UPDATE_COMMAND_UI(ID_TOOL_VIEW, OnUpdateToolView)
	ON_COMMAND(ID_EDIT_DELETE, OnEditDelete)
	ON_COMMAND(ID_SELECT_ALL, OnSelectAll)
	ON_UPDATE_COMMAND_UI(ID_SELECT_ALL, OnUpdateSelectAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_SEPARATOR,
	ID_SEPARATOR,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	
}

/////////////////////////////////////////////////////////////////////////////
// 

CMainFrame::~CMainFrame()
{
}

/////////////////////////////////////////////////////////////////////////////
// 

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	HFONT	hFont = (HFONT)::GetStockObject( DEFAULT_GUI_FONT );

	if( hFont == NULL )
		hFont = (HFONT)::GetStockObject( ANSI_VAR_FONT );

  	m_wndStatusBar.SendMessage( WM_SETFONT, (WPARAM)hFont );	// change font

	CClientDC	dc( &m_wndStatusBar );
	CFont	cFont;

	cFont.CreateStockObject( DEFAULT_GUI_FONT );
	dc.SelectObject( &cFont );

	TEXTMETRIC	tm;

	dc.GetTextMetrics( &tm );
	SIZE	sz;

	m_wndStatusBar.SetPaneInfo( 0, ID_SEPARATOR, SBPS_STRETCH | SBPS_NORMAL, 0 );

	sz = dc.GetTextExtent( SFSUT_SET_NUM, lstrlen( SFSUT_SET_NUM ) );
	m_wndStatusBar.SetPaneInfo( SFSUT_NUM_INDEX, ID_SEPARATOR, SBPS_NORMAL, sz.cx );

	sz = dc.GetTextExtent( SFSUT_SET_SVC, lstrlen( SFSUT_SET_SVC ) );
	m_wndStatusBar.SetPaneInfo( SFSUT_SVC_INDEX, ID_SEPARATOR, SBPS_NORMAL, sz.cx );

	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜
	//       ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// 

BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	// Xvbgo[ŃNCAg̈𕪊
	// create a splitter with 1 row, 2 columns
	if( !m_wndSplitter.CreateStatic( this, 1, 2 ) ) {
		TRACE0( "Failed to CreateStaticSplitter\n" );
		return FALSE;
	}

	// add the first splitter pane - the default view in column 0
	if( !m_wndSplitter.CreateView( 0, 0, RUNTIME_CLASS(CSFTreeView), CSize(128, 0), pContext ) ) {
		TRACE0( "Failed to create first pane\n" );
		return FALSE;
	}

	// add the second splitter pane - an input view in column 1
	if( !m_wndSplitter.CreateView( 0, 1, RUNTIME_CLASS(CSFListView), CSize(0, 0), pContext ) ) {
		TRACE0( "Failed to create second pane\n" );
		return FALSE;
	}

	// activate the input view
	SetActiveView( (CView*)m_wndSplitter.GetPane( 0, 1 ) );

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// 

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB

	cs.x = 32;
	cs.y = 64;
	cs.cx = 869;
	cs.cy = 385;

	cs.cx = 600;
	cs.cy = 400;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh


BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ

	// Route to standard command targets first
	if( CFrameWnd::OnCmdMsg( nID, nCode, pExtra, pHandlerInfo ) )
		return TRUE;

	// Route to inactive views second
	CMonLogDoc*	pDoc = (CMonLogDoc*)GetActiveDocument();
	if( pDoc != NULL ) {
		if( pDoc->RouteCmdToAllViews( GetActiveView(), nID, nCode, pExtra, pHandlerInfo ) )
			return TRUE;
	}

	return FALSE;
}

void CMainFrame::OnOpeUpdate() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CMonLogDoc*	pDoc = (CMonLogDoc*)GetActiveDocument();
	CMonLogApp*	pApp = (CMonLogApp*)AfxGetApp();

	if( pDoc && pApp ) {
		CSFTreeView*	pTree = pDoc->GetTreeView();
		CSFListView*	pList = pDoc->GetListView();

		HTREEITEM	hItem = pTree->GetTreeCtrl().GetSelectedItem();
		CString	csSelect = pTree->GetTreeCtrl().GetItemText( hItem );

		::EnterCriticalSection( &pDoc->m_CS_CurList );
		if( pDoc->m_dwCurList == SFLIST_NONE ) {
			::LeaveCriticalSection( &pDoc->m_CS_CurList );
			return;
		}
		pDoc->m_dwCurList = SFLIST_NONE;
		::LeaveCriticalSection( &pDoc->m_CS_CurList );

		pList->ResetListView();

		if(  csSelect == "M" ) {
			lstrcpy( pApp->m_szExecCheckTitle, "M XV" );
			pApp->ProgressStart( this );
			pApp->ReloadIndex( &pApp->m_infoQue );
			pApp->ProgressEnd();
		}
		else if(  csSelect == "M" ) {

			lstrcpy( pApp->m_szExecCheckTitle, "M XV" );
			pApp->ProgressStart( this );
			pApp->ReloadIndex( &pApp->m_infoSend );
			pApp->ProgressEnd();
		}
		else if(  csSelect == "M" ) {
			lstrcpy( pApp->m_szExecCheckTitle, "M XV" );
			pApp->ProgressStart( this );
			pApp->ReloadIndex( &pApp->m_infoRecv );
			pApp->ProgressEnd();
		}

		pDoc->GetTreeView()->UpdateDisplay();
	}
}

void CMainFrame::OnUpdateOpeUpdate(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
	pCmdUI->Enable( CheckCmdUiStatus( FALSE ) );
}

void CMainFrame::OnEditDelete() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ

	CPtrArray	*pDelList = (CPtrArray *)NULL;

	int	iJobID = 0;

	CMonLogDoc*	pDoc = (CMonLogDoc*)GetActiveDocument();
	CMonLogApp*	pApp = (CMonLogApp*)AfxGetApp();

	pDelList = new CPtrArray;
	if( !pDelList  ) {
		goto	EXIT;
	}

	if( pDoc && pApp ) {

		CSFTreeView*	pTree = pDoc->GetTreeView();
		HTREEITEM	hItem = pTree->GetTreeCtrl().GetSelectedItem();
		CString	csSelect = pTree->GetTreeCtrl().GetItemText( hItem );

		CSFListView*	pList = pDoc->GetListView();

		POSITION pos = pList->GetListCtrl().GetFirstSelectedItemPosition();

		while(  pos ) {
			int	nItem = pList->GetListCtrl().GetNextSelectedItem( pos );

			SFLIST_ITEMINFO	*pItem = (SFLIST_ITEMINFO *)( pList->GetListCtrl().GetItemData( nItem )) ;

			if( pItem && pItem->pData ) {

				if( ( csSelect == "M" ) ||
					( csSelect == "M" ) ||
					( csSelect == "M" ) ) {


					RIDX_DATINFO	*pIdxRec;

					pIdxRec = (RIDX_DATINFO *)pItem->pData;

					if( pIdxRec->pJobID && pIdxRec->iJobID ) {

						char	*pAdd;

						pAdd = new char[64+1];
						if( pAdd ) {
							CopyMemory( pAdd, pIdxRec->pJobID, 64+1 );
							pDelList->Add( pAdd );

							iJobID++;
						}
						else {
							goto	EXIT;
						}
					}
				}
			}
		}

		if( iJobID) {

			CSFListView*	pList = pDoc->GetListView();

			char	*pMsg = (char *)NULL;
			int	iMsgRet = IDCANCEL;

			if(  csSelect == "M" ) {
				pMsg = SFMSG_DELETE_QUE;
			}
			else if(  csSelect == "M" ) {
				pMsg = SFMSG_DELETE_SEND;
			}
			else if(  csSelect == "M" ) {
				pMsg = SFMSG_DELETE_RECV;
			}

			if( pMsg ) {
				iMsgRet = AfxMessageBox( pMsg, MB_OKCANCEL | MB_ICONQUESTION );
			}
			if( iMsgRet != IDOK ) {
				goto	EXIT;
			}

			::EnterCriticalSection( &pDoc->m_CS_CurList );
			pDoc->m_dwCurList = SFLIST_NONE;
			::LeaveCriticalSection( &pDoc->m_CS_CurList );

			pList->ResetListView();

			if(  csSelect == "M" ) {
				pApp->DeleteQue( pDelList );
			}
			else if(  csSelect == "M" ) {
				pApp->DeleteSend( pDelList );
			}
			else if(  csSelect == "M" ) {
				pApp->DeleteRecv( pDelList );
			}

			pDoc->GetTreeView()->UpdateDisplay();
		}
	}

EXIT:

	if( pDelList ) {

		char	*pDelDat;
		int	i;

		for( i = 0 ; i < pDelList->GetSize() ; i++ ) {
			pDelDat = (char *)pDelList->GetAt( i );
			delete pDelDat;
		}
		pDelList->RemoveAll();
		delete pDelList;
	}

}

void CMainFrame::OnUpdateEditDelete(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
	BOOL	bCmdUI = CheckCmdUiStatus( TRUE );

	if( bCmdUI ) {
		bCmdUI = FALSE;

		CMonLogDoc*	pDoc = (CMonLogDoc*)GetActiveDocument();
		CWnd*	pWnd = GetFocus();	
		CSFListView*	pList = pDoc->GetListView();

		if( pWnd != (CWnd*)pList ) {
			goto	EXIT;
		}
		if( !( pList->GetListCtrl().GetSelectedCount() ) ) {
			goto	EXIT;
		}

		bCmdUI = TRUE;
	}

EXIT:

	pCmdUI->Enable( bCmdUI );
}

void CMainFrame::OnSelectAll() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	
	CMonLogDoc*	pDoc = (CMonLogDoc*)GetActiveDocument();
	CMonLogApp*	pApp = (CMonLogApp*)AfxGetApp();

	if( pDoc && pApp ) {

		CSFTreeView*	pTree = pDoc->GetTreeView();
		CWnd*	pWnd = GetFocus();	
		CSFListView*	pList = pDoc->GetListView();

		if( pWnd != (CWnd*)pList ) {
			goto	EXIT;
		}

		if( pList ) {
			for( int i = 0  ; i < pList->GetListCtrl().GetItemCount() ; i++ ) {
				pList->GetListCtrl().SetItemState( i, LVIS_SELECTED, LVIS_SELECTED );
			}
		}
	}

EXIT:

	return;
}

void CMainFrame::OnUpdateSelectAll(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
	BOOL	bCmdUI = CheckCmdUiStatus( TRUE );

	if( bCmdUI ) {
		bCmdUI = FALSE;

		CMonLogDoc*	pDoc = (CMonLogDoc*)GetActiveDocument();
		CWnd*	pWnd = GetFocus();	
		CSFListView*	pList = pDoc->GetListView();

		if( pWnd != (CWnd*)pList ) {
			goto	EXIT;
		}

		bCmdUI = TRUE;
	}

EXIT:

	pCmdUI->Enable( bCmdUI );
}

void CMainFrame::OnUpdateToolView(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	
	BOOL	bCmdUI = CheckCmdUiStatus( TRUE );

	if( bCmdUI ) {
		bCmdUI = FALSE;

		CMonLogDoc*	pDoc = (CMonLogDoc*)GetActiveDocument();
		CWnd*	pWnd = GetFocus();	
		CSFListView*	pList = pDoc->GetListView();

		if( pWnd != (CWnd*)pList ) {
			goto	EXIT;
		}
		if( !( pList->GetListCtrl().GetSelectedCount() ) ) {
			goto	EXIT;
		}

		bCmdUI = TRUE;
	}

EXIT:

	pCmdUI->Enable( bCmdUI );
}

BOOL CMainFrame::CheckCmdUiStatus( BOOL bData )

{
	CWnd*	pWnd = GetFocus();	
	CMonLogDoc*	pDoc = (CMonLogDoc*)GetActiveDocument();
	CMonLogApp*	pApp = (CMonLogApp*)AfxGetApp();

	BOOL	bCmdUI = FALSE;

	if( pWnd && pDoc && pApp ) {

		CSFTreeView*	pTree = pDoc->GetTreeView();
		CSFListView*	pList = pDoc->GetListView();

		BOOL	bRun = SFCSSYS_GetRunInfoInt( SFCS_SEC_RUNSFCS, SFCS_KEY_RUNRUN, 0 );

		CSFStatusInfo::svcTextOut( bRun );

		if( pWnd != (CWnd*)pTree && pWnd != (CWnd*)pList ) {
			goto	EXIT;
		}

		HTREEITEM	hItem = pTree->GetTreeCtrl().GetSelectedItem();
		CString	csSelect = pTree->GetTreeCtrl().GetItemText( hItem );

		if(  csSelect == "M" ) {
			if( !pApp->m_bQue ) {
				goto	EXIT;
			}
			if( bData ) {
				if( !pApp->m_infoQue.iDataInfo ) {
					goto	EXIT;
				}
			}
		}
		else if(  csSelect == "M" ) {

			if( !pApp->m_bSend ) {
				goto	EXIT;
			}
			if( bData ) {
				if( !pApp->m_infoSend.iDataInfo ) {
					goto	EXIT;
				}
			}
		}
		else if(  csSelect == "M" ) {
			if( !pApp->m_bRecv ) {
				goto	EXIT;
			}
			if( bData ) {
				if( !pApp->m_infoRecv.iDataInfo ) {
					goto	EXIT;
				}
			}
		}
		else {
			goto	EXIT;
		}

		bCmdUI = TRUE;
	}

EXIT:

	return bCmdUI;
}

CStatusBar* CMainFrame::GetStatusBar()
{
	ASSERT_VALID( &m_wndStatusBar );
	return &m_wndStatusBar;
}

