#if !defined(AFX_SFTREEVIEW_H__F7823611_1BC1_4CF3_95E3_1DFDB2621735__INCLUDED_)
#define AFX_SFTREEVIEW_H__F7823611_1BC1_4CF3_95E3_1DFDB2621735__INCLUDED_

//#if _MSC_VER > 1000
#pragma once
//#endif // _MSC_VER > 1000
// SFTreeView.h : wb_[ t@C
//

#include "MonLogDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CSFTreeView r[

class CSFTreeView : public CTreeView
{
protected:
	CSFTreeView();           // IɎgpveNg RXgN^
	DECLARE_DYNCREATE(CSFTreeView)

    CImageList m_imglDrives;

	CMonLogApp* m_pApp;

    int InitTree( void );
    BOOL AddRootNode( void );
    BOOL SetButtonState( HTREEITEM hItem, CString& strPath );
    CString GetPathFromNode( HTREEITEM hItem );
    int AddDirectories( HTREEITEM hItem, CString& strPath );
    void DeleteFirstChild( HTREEITEM hParent );
    void DeleteAllChildren( HTREEITEM hParent );

// Agr[g
public:
	CMonLogDoc* GetDocument();

// Iy[V
public:
	void UpdateDisplay( void );

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B

	//{{AFX_VIRTUAL(CSFTreeView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
    virtual void OnSelectionChanged( CString& strPath, BOOL bSelect = FALSE );
	protected:
	virtual void OnDraw(CDC* pDC);      // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual void OnInitialUpdate(); // \z̍ŏ̂PxĂяo܂B
	//}}AFX_VIRTUAL

// Cve[V
protected:
	virtual ~CSFTreeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CSFTreeView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnOpeUpdate();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // SFWIFAXTreeView.cpp t@CfobO̎gp܂B
inline CMonLogDoc* CSFTreeView::GetDocument()
   { return (CMonLogDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SFTREEVIEW_H__F7823611_1BC1_4CF3_95E3_1DFDB2621735__INCLUDED_)
